Debian Bug report logs - #535767
[debcheckout] Allow for debian/-only repositories

version graph

Package: devscripts; Maintainer for devscripts is Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>; Source for devscripts is src:devscripts.

Reported by: Joachim Breitner <nomeata@debian.org>

Date: Sat, 4 Jul 2009 20:45:02 UTC

Severity: wishlist

Found in version devscripts/2.10.52

Fixed in version devscripts/2.10.70

Done: James Vega <jamessan@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#535767; Package devscripts. (Sat, 04 Jul 2009 20:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
New Bug report received and forwarded. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Sat, 04 Jul 2009 20:45:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Allow for debian/-only repositories
Date: Sat, 04 Jul 2009 22:41:53 +0200
Package: devscripts
Version: 2.10.52
Severity: wishlist
File: /usr/bin/debcheckout

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Hi zack,

while setting up the pkg-haskell group, we had some discussions on the
VCS layout.

One option, which I find appealing, is to only store the contents of the
debian/ directory in the VCS. This would be most useful if there is
some support for it in debcheckout. In human pseudo code, I could
imagine debcheckout following these steps:

 * debcheckout, after getting the repository, detects this layout
   (absense of a debian/ directory, presence of control and changelog
   files in the top directory)
 * If detected, it gets an upstream tarball. Possible locations are:
   - current working directory, if named as expected (....orig.tar.gz)
   - the debian archive
   - whatever is referenced in ./watch
 * It extracts the tarball
 * It moves the repository checkout to debian/ inside the checked-out
   sources.

What do you think? Does it make sense? Would you accept a patch
implementing that?

Thanks,
Joachim

- -- Package-specific info:

- --- /etc/devscripts.conf ---

- --- ~/.devscripts ---
DEBCHANGE_RELEASE_HEURISTIC=changelog
DEBRELEASE_UPLOADER=dput

- -- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.29-2-amd64 (SMP w/2 CPU cores)
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages devscripts depends on:
ii  dpkg-dev                      1.15.3     Debian package development tools
ii  libc6                         2.9-18     GNU C Library: Shared libraries
ii  perl                          5.10.0-23  Larry Wall's Practical Extraction 

Versions of packages devscripts recommends:
ii  at                 3.1.10.2              Delayed job execution and batch pr
ii  bsd-mailx [mailx]  8.1.2-0.20081101cvs-2 A simple mail user agent
ii  bzr                1.16.1-1              easy to use distributed version co
ii  curl               7.19.5-1              Get a file from an HTTP, HTTPS or 
ii  cvs                1:1.12.13-12          Concurrent Versions System
ii  dctrl-tools        2.13.1                Command-line tools to process Debi
ii  debian-keyring     2009.05.28            GnuPG (and obsolete PGP) keys of D
pn  debian-maintainers <none>                (no description available)
ii  dput               0.9.4                 Debian package upload tool
ii  equivs             2.0.7-0.1             Circumvent Debian package dependen
ii  fakeroot           1.12.4                Gives a fake root environment
ii  galeon [www-browse 2.0.7-1               GNOME web browser for advanced use
ii  git-core           1:1.6.3.3-2           fast, scalable, distributed revisi
ii  gnupg              1.4.9-4               GNU privacy guard - a free PGP rep
ii  iceweasel [www-bro 3.0.11-1              lightweight web browser based on M
ii  libauthen-sasl-per 2.12-1                Authen::SASL - SASL Authentication
ii  libcrypt-ssleay-pe 0.57-1+b1             Support for https protocol in LWP
ii  libparse-debcontro 2.005-2               Easy OO parsing of Debian control-
ii  libsoap-lite-perl  0.710.08-2            Client and server side SOAP implem
ii  libterm-size-perl  0.2-4+b1              Perl extension for retrieving term
ii  libtimedate-perl   1.1600-9              Time and date functions for Perl
ii  liburi-perl        1.37+dfsg-1           Manipulates and accesses URI strin
ii  libwww-perl        5.828-1               WWW client/server library for Perl
ii  libyaml-syck-perl  1.07-1                fast, lightweight YAML loader and 
ii  lintian            2.2.12                Debian package checker
ii  lsb-release        3.2-22                Linux Standard Base version report
ii  lynx-cur [www-brow 2.8.7pre6-1           Text-mode WWW Browser with NLS sup
ii  man-db             2.5.5-2               on-line manual pager
ii  mercurial          1.2.1-3               scalable distributed version contr
ii  openssh-client [ss 1:5.1p1-6             secure shell client, an rlogin/rsh
ii  patch              2.5.9-5               Apply a diff file to an original
ii  patchutils         0.3.1-2               Utilities to work with patches
ii  strace             4.5.18-1              A system call tracer
ii  subversion         1.5.6dfsg-1           Advanced version control system
ii  unzip              6.0-1                 De-archiver for .zip files
ii  w3m [www-browser]  0.5.2-2.1             WWW browsable pager with excellent
ii  wdiff              0.5-18                Compares two files word by word
ii  wget               1.11.4-2              retrieves files from the web

Versions of packages devscripts suggests:
ii  build-essential               11.4       Informational list of build-essent
pn  cvs-buildpackage              <none>     (no description available)
pn  devscripts-el                 <none>     (no description available)
pn  gnuplot                       <none>     (no description available)
pn  libfile-desktopentry-perl     <none>     (no description available)
ii  libnet-smtp-ssl-perl          1.01-2     SSL support for Net::SMTP
pn  mutt                          <none>     (no description available)
pn  svn-buildpackage              <none>     (no description available)

- -- no debconf information

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkpPvpEACgkQ9ijrk0dDIGwopQCfSuz3ZUgFCE/D47mcJPz48q8M
RJEAoJTZSo6CORNffVKCg3zJr194rVR4
=Rx5B
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#535767; Package devscripts. (Sun, 05 Jul 2009 09:03:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stefano Zacchiroli <zack@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Sun, 05 Jul 2009 09:03:09 GMT) Full text and rfc822 format available.

Message #10 received at 535767@bugs.debian.org (full text, mbox):

From: Stefano Zacchiroli <zack@debian.org>
To: Joachim Breitner <nomeata@debian.org>, 535767@bugs.debian.org
Subject: Re: Bug#535767: Allow for debian/-only repositories
Date: Sun, 5 Jul 2009 10:57:17 +0200
[Message part 1 (text/plain, inline)]
On Sat, Jul 04, 2009 at 10:41:53PM +0200, Joachim Breitner wrote:
> Hi zack,

Howdy (but note that devscripts, including debcheckout, is maintained
by way more people than me alone ;-))

> One option, which I find appealing, is to only store the contents of the
> debian/ directory in the VCS. This would be most useful if there is
> some support for it in debcheckout. In human pseudo code, I could
> imagine debcheckout following these steps:
> 
>  * debcheckout, after getting the repository, detects this layout
>    (absense of a debian/ directory, presence of control and changelog
>    files in the top directory)
>  * If detected, it gets an upstream tarball. Possible locations are:
>    - current working directory, if named as expected (....orig.tar.gz)
>    - the debian archive
>    - whatever is referenced in ./watch
>  * It extracts the tarball
>  * It moves the repository checkout to debian/ inside the checked-out
>    sources.
> 
> What do you think? Does it make sense? Would you accept a patch
> implementing that?

First of all, I must confess that I don't see the advantage. Are you
doing all that only to gain the storage of the _content_ of debian/
instead of having a repository that contains debian/ itself? If this
is the case, I noticed that what you are proposing will defeat the
implicit API of many devscripts, which expect a debian/ dir inside
`pwd`. ... and in fact you are asking debcheckout to recreate that
layout: it looks like _very_ twisted to me.

If, on the contrary, what you are trying to achieve is to not store
upstream sources but only debian/ stuff, then for some $VCS you
already have support for that in package building tool. For instance,
svn-buildpackage supports the so called "debian only" layout which
does exactly that. Using such a tool, the work flow you request is
already available executing a couple of commands:

- debcheckout foo
- uscan --force-download
- # move downloaded stuff in ../tarballs/

And you're done.

2 comments:

1) this is because svn-buildpackage has knowledge of some "debian
   only" layout. Does your $VCS support, with its package building
   tool, anything like that? If not, there is probably where to add
   the support you need

2) how to actually retrieve the orig tarball is a tricky
   business. uscan is a possibility, the "get-orig-source" of
   debian/rules is another. How to find an entry point which does the
   right thing is a complex subject by his own, which probably
   requires some adjustments in policy too.

Concluding, as I see things now, it doesn't look like a good idea to
me to implement what you asked, ... but I might have misunderstood it
:-)

Cheers.

-- 
Stefano Zacchiroli -o- PhD in Computer Science \ PostDoc @ Univ. Paris 7
zack@{upsilon.cc,pps.jussieu.fr,debian.org} -<>- http://upsilon.cc/zack/
Dietro un grande uomo c'è ..|  .  |. Et ne m'en veux pas si je te tutoie
sempre uno zaino ...........| ..: |.... Je dis tu à tous ceux que j'aime
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#535767; Package devscripts. (Sun, 05 Jul 2009 09:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Sun, 05 Jul 2009 09:42:03 GMT) Full text and rfc822 format available.

Message #15 received at 535767@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Stefano Zacchiroli <zack@debian.org>
Cc: 535767@bugs.debian.org
Subject: Re: Bug#535767: Allow for debian/-only repositories
Date: Sun, 05 Jul 2009 11:35:58 +0200
[Message part 1 (text/plain, inline)]
Hi,

Am Sonntag, den 05.07.2009, 10:57 +0200 schrieb Stefano Zacchiroli:
> On Sat, Jul 04, 2009 at 10:41:53PM +0200, Joachim Breitner wrote:
> > Hi zack,
> 
> Howdy (but note that devscripts, including debcheckout, is maintained
> by way more people than me alone ;-))

I checked the manpage for the mention of an author :-)

> First of all, I must confess that I don't see the advantage. Are you
> doing all that only to gain the storage of the _content_ of debian/
> instead of having a repository that contains debian/ itself? If this
> is the case, I noticed that what you are proposing will defeat the
> implicit API of many devscripts, which expect a debian/ dir inside
> `pwd`. ... and in fact you are asking debcheckout to recreate that
> layout: it looks like _very_ twisted to me.

On the developer’s machine, I want the regular layout where debian/ is
in $PWD, just that not the whole $PWD is in the VCS (I’m thinking of
darcs), but only debian/. The main goal is to keep the repository small
and slick.

> If, on the contrary, what you are trying to achieve is to not store
> upstream sources but only debian/ stuff, then for some $VCS you
> already have support for that in package building tool. For instance,
> svn-buildpackage supports the so called "debian only" layout which
> does exactly that. Using such a tool, the work flow you request is
> already available executing a couple of commands:
> 
> - debcheckout foo
> - uscan --force-download
> - # move downloaded stuff in ../tarballs/
> 
> And you're done.

I knew I saw something like that once. svn-buildpackage even has code to
to fetch the tarball from the archive or, when not found, via watch.

if($opt_download_tarball) {
    if(!defined($origfile)) {
        print "Trying to download tarball using apt\n";
        my $olddir = getcwd();
        mychdir $$c{"origDir"};
        my @archive_versions = split("\n", `apt-cache policy $package`);
        @archive_versions = grep /^(( \*\*\* |     )[0-9])/, @archive_versions;
        map {$_ =~ s/^ \*\*\* /     /; $_ =~ s/^     ([^ ]+) .*$/$1/; $_} @archive_versions;
        foreach(@archive_versions) {
            my $upstream_version = "$_";
            $upstream_version =~ s/^.*://;
            $upstream_version =~ s/(.*)-([^-]+)/$1/;
            if($upstream_version eq $upVersion) {
                system("apt-get source --tar-only $package=$_");
                if(($? >> 8) == 0 && -f $orig) {
                    $origfile = long_path($orig);
                    last;
                }
            }
        }
        mychdir $olddir;
    }
    if(-f "debian/watch" && !defined($origfile)) {
        print "Trying to download tarball using uscan\n";
        system("uscan", "--destdir", $$c{"origDir"}, "--repack", "--download-version", $upVersion, "--force-download");
        if(-f $$c{"origDir"} . "/$orig") {
            $origfile = long_path($$c{"origDir"} . "/$orig");
        }
    };
    if($opt_download_tarball && !defined($origfile)) {
        die("Couldn't find a tarball\n");
    }
}


Having it in debcheckout would make it possible to use it with other
VCSes as well, i.e. darcs. The code above can probably be used without
much changes.

> 2 comments:
> 
> 1) this is because svn-buildpackage has knowledge of some "debian
>    only" layout. Does your $VCS support, with its package building
>    tool, anything like that? If not, there is probably where to add
>    the support you need

darcs-buildpackage does not have the support. And, since the support
only affects the _retrieving_ of the source, I don’t see much merit in
using darcs-buildpackage at all. Following the unix philosophy of small
tools, I’d use
 * debcheckout to get the sources and set them up correctly
 * regular dpkg-buildpackage -I to build
 * regular darcs (inside ./debian/) to commit, tag and push changes

> 2) how to actually retrieve the orig tarball is a tricky
>    business. uscan is a possibility, the "get-orig-source" of
>    debian/rules is another. How to find an entry point which does the
>    right thing is a complex subject by his own, which probably
>    requires some adjustments in policy too.

Given that there is code in svn-buildpackage, I’d think it’s feasible.
I’d expect that only those maintainers will use such the feature where
it actually works :-)

> Concluding, as I see things now, it doesn't look like a good idea to
> me to implement what you asked, ... but I might have misunderstood it
> :-)

Ok. I guess, at first, I can wrap the functionality in a shell script
for our team (if we even decide on such a repository layout). If it
works out, we can still consider adding it to debcheckout.

Thanks for your comments,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#535767; Package devscripts. (Sun, 05 Jul 2009 13:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stefano Zacchiroli <zack@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Sun, 05 Jul 2009 13:06:03 GMT) Full text and rfc822 format available.

Message #20 received at 535767@bugs.debian.org (full text, mbox):

From: Stefano Zacchiroli <zack@debian.org>
To: Joachim Breitner <nomeata@debian.org>
Cc: 535767@bugs.debian.org
Subject: Re: Bug#535767: Allow for debian/-only repositories
Date: Sun, 5 Jul 2009 15:03:31 +0200
On Sun, Jul 05, 2009 at 11:35:58AM +0200, Joachim Breitner wrote:
> I knew I saw something like that once. svn-buildpackage even has code to
> to fetch the tarball from the archive or, when not found, via watch.

Thanks for the code, I did not know that.
Still, duplicating code is always bad. So, if we really want to go
this way, I'd prefer to add support to debcheckout to invoke some kind
of hooks, and have this as a possible hook. How about that?

> darcs-buildpackage does not have the support. And, since the support
> only affects the _retrieving_ of the source, I don’t see much merit in
> using darcs-buildpackage at all. Following the unix philosophy of small
> tools, I’d use

I disagree on this. With svn-buildpackage the debian only layout is
used at build time. You never have upstream code unpacked where you
are, but rather elsewhere. That elsewhere is unpacked upon build.

> Given that there is code in svn-buildpackage, I’d think it’s
> feasible.  I’d expect that only those maintainers will use such the
> feature where it actually works :-)

It's feasible, the point is whether the implementation is the right
way to go. Before going that way, I'd rather trigger a discussion on
-devel about that. For instance, what if get-orig-source invokes uscan
itself?

Cheers.

-- 
Stefano Zacchiroli -o- PhD in Computer Science \ PostDoc @ Univ. Paris 7
zack@{upsilon.cc,pps.jussieu.fr,debian.org} -<>- http://upsilon.cc/zack/
Dietro un grande uomo c'è ..|  .  |. Et ne m'en veux pas si je te tutoie
sempre uno zaino ...........| ..: |.... Je dis tu à tous ceux que j'aime




Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#535767; Package devscripts. (Sun, 05 Jul 2009 15:57:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Sun, 05 Jul 2009 15:57:13 GMT) Full text and rfc822 format available.

Message #25 received at 535767@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Stefano Zacchiroli <zack@debian.org>
Cc: 535767@bugs.debian.org
Subject: Re: Bug#535767: Allow for debian/-only repositories
Date: Sun, 05 Jul 2009 17:52:27 +0200
[Message part 1 (text/plain, inline)]
Hi Zack,

Am Sonntag, den 05.07.2009, 15:03 +0200 schrieb Stefano Zacchiroli:
> On Sun, Jul 05, 2009 at 11:35:58AM +0200, Joachim Breitner wrote:
> > I knew I saw something like that once. svn-buildpackage even has code to
> > to fetch the tarball from the archive or, when not found, via watch.
> 
> Thanks for the code, I did not know that.
> Still, duplicating code is always bad. So, if we really want to go
> this way, I'd prefer to add support to debcheckout to invoke some kind
> of hooks, and have this as a possible hook. How about that?

You mean a hook inside the checked-out-repository? E.g. a file
"debcheckout-hook" that, if present, will always be called by
debcheckout? Seems to be risky security-wise.

> > darcs-buildpackage does not have the support. And, since the support
> > only affects the _retrieving_ of the source, I don’t see much merit in
> > using darcs-buildpackage at all. Following the unix philosophy of small
> > tools, I’d use
> 
> I disagree on this. With svn-buildpackage the debian only layout is
> used at build time. You never have upstream code unpacked where you
> are, but rather elsewhere. That elsewhere is unpacked upon build.

I only saw that function, I didn’t really follow through how it’s used
in svn-buildpackage.

A piece of code says more than thousands words, so here is a prototypial
wrapper:
http://people.debian.org/~nomeata/pkg-haskell-checkout

> > Given that there is code in svn-buildpackage, I’d think it’s
> > feasible.  I’d expect that only those maintainers will use such the
> > feature where it actually works :-)
> 
> It's feasible, the point is whether the implementation is the right
> way to go. Before going that way, I'd rather trigger a discussion on
> -devel about that. For instance, what if get-orig-source invokes uscan
> itself?

I haven’t worked with get-orig-source before. Is it a standard? I
thought it’s only a thin people use personally.


I think I’ll stop bugging you for a while and work with the shell script
linked above. If it turns out to be a good way of using a repository,
I’ll come back and we can pick up the discussion. Or we talk about this
at DebConf :-)

Greetings,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#535767; Package devscripts. (Sun, 05 Jul 2009 16:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stefano Zacchiroli <zack@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Sun, 05 Jul 2009 16:57:02 GMT) Full text and rfc822 format available.

Message #30 received at 535767@bugs.debian.org (full text, mbox):

From: Stefano Zacchiroli <zack@debian.org>
To: Joachim Breitner <nomeata@debian.org>
Cc: 535767@bugs.debian.org
Subject: Re: Bug#535767: Allow for debian/-only repositories
Date: Sun, 5 Jul 2009 18:53:42 +0200
On Sun, Jul 05, 2009 at 05:52:27PM +0200, Joachim Breitner wrote:
> > Thanks for the code, I did not know that.
> > Still, duplicating code is always bad. So, if we really want to go
> > this way, I'd prefer to add support to debcheckout to invoke some kind
> > of hooks, and have this as a possible hook. How about that?
> 
> You mean a hook inside the checked-out-repository? E.g. a file
> "debcheckout-hook" that, if present, will always be called by
> debcheckout? Seems to be risky security-wise.

No, I meant a hook on your machine which is executed always and which
will try to checkout upstream sources if they aren't there. Actually,
also the solution of a hook in the checked out repository might do the
trick, but as you observer will need an explicitly enabling flag that
triggers that only on repositories which are known to be "safe".

> A piece of code says more than thousands words, so here is a prototypial
> wrapper:
> http://people.debian.org/~nomeata/pkg-haskell-checkout

Urm, I understand the deal, but I'd prefer it to support
get-orig-source, read on.

> I haven’t worked with get-orig-source before. Is it a standard? I
> thought it’s only a thin people use personally.

Yup, is in policy. It is the target to use if your upstream tarball
needs some kind of mangling (e.g., stripping non-DFSG bits or packing
together multiple upstream tarballs for multi-upstream source
packages). What I'd love from your script is to test if
get-orig-source is defined (possibly invoking make in some dry-run
way, not just parsing debian/rules cause it can include other files)
before trying uscan.

> Or we talk about this at DebConf :-)

Deal :-)

Cheers.

-- 
Stefano Zacchiroli -o- PhD in Computer Science \ PostDoc @ Univ. Paris 7
zack@{upsilon.cc,pps.jussieu.fr,debian.org} -<>- http://upsilon.cc/zack/
Dietro un grande uomo c'è ..|  .  |. Et ne m'en veux pas si je te tutoie
sempre uno zaino ...........| ..: |.... Je dis tu à tous ceux que j'aime




Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#535767; Package devscripts. (Sun, 05 Jul 2009 18:12:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Sun, 05 Jul 2009 18:12:02 GMT) Full text and rfc822 format available.

Message #35 received at 535767@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Stefano Zacchiroli <zack@debian.org>
Cc: 535767@bugs.debian.org
Subject: Re: Bug#535767: Allow for debian/-only repositories
Date: Sun, 05 Jul 2009 20:09:37 +0200
[Message part 1 (text/plain, inline)]
Hi,

Am Sonntag, den 05.07.2009, 18:53 +0200 schrieb Stefano Zacchiroli:
> > I haven’t worked with get-orig-source before. Is it a standard? I
> > thought it’s only a thin people use personally.
> 
> Yup, is in policy. It is the target to use if your upstream tarball
> needs some kind of mangling (e.g., stripping non-DFSG bits or packing
> together multiple upstream tarballs for multi-upstream source
> packages). What I'd love from your script is to test if
> get-orig-source is defined (possibly invoking make in some dry-run
> way, not just parsing debian/rules cause it can include other files)
> before trying uscan.

Of course, "./rules get-orig-source" has the same security implications
than a hook. (In a sense, it is a hook.)

Is it really desirable to use an imperative feature (run this Makefile
rule to get the tarball), when there is a declarative way of doing it
(the watch file) as well?

I’d say as long as someone does not have to modify the tarball, using
debian/watch and uscan should be preferred to coding stuff in
get-orig-source. 

Greetings,
Joachim
-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#535767; Package devscripts. (Sun, 05 Jul 2009 18:39:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stefano Zacchiroli <zack@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Sun, 05 Jul 2009 18:39:04 GMT) Full text and rfc822 format available.

Message #40 received at 535767@bugs.debian.org (full text, mbox):

From: Stefano Zacchiroli <zack@debian.org>
To: Joachim Breitner <nomeata@debian.org>
Cc: 535767@bugs.debian.org
Subject: Re: Bug#535767: Allow for debian/-only repositories
Date: Sun, 5 Jul 2009 20:36:54 +0200
On Sun, Jul 05, 2009 at 08:09:37PM +0200, Joachim Breitner wrote:
> Is it really desirable to use an imperative feature (run this Makefile
> rule to get the tarball), when there is a declarative way of doing it
> (the watch file) as well?

Yes, but that discussion does not belong here. Check policy, use
cases, or related discussions. (And, BTW, a lot of uscan options are
totally non-declarative ...)

> I’d say as long as someone does not have to modify the tarball, using
> debian/watch and uscan should be preferred to coding stuff in
> get-orig-source. 

... but well, *modifying* tarball is exactly the main use case of
get-orig-source.

-- 
Stefano Zacchiroli -o- PhD in Computer Science \ PostDoc @ Univ. Paris 7
zack@{upsilon.cc,pps.jussieu.fr,debian.org} -<>- http://upsilon.cc/zack/
Dietro un grande uomo c'è ..|  .  |. Et ne m'en veux pas si je te tutoie
sempre uno zaino ...........| ..: |.... Je dis tu à tous ceux que j'aime




Changed Bug title to '[debcheckout] Allow for debian/-only repositories' from 'Allow for debian/-only repositories' Request was from Adam D. Barratt <adam@adam-barratt.org.uk> to control@bugs.debian.org. (Fri, 24 Jul 2009 10:09:05 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Christoph Berg <myon@debian.org> to control@bugs.debian.org. (Fri, 31 Dec 2010 18:45:05 GMT) Full text and rfc822 format available.

Message sent on to Joachim Breitner <nomeata@debian.org>:
Bug#535767. (Fri, 31 Dec 2010 18:45:09 GMT) Full text and rfc822 format available.

Message #47 received at 535767-submitter@bugs.debian.org (full text, mbox):

From: Christoph Berg <myon@debian.org>
To: 535767-submitter@bugs.debian.org
Subject: Bug#535767 marked as pending
Date: Fri, 31 Dec 2010 18:41:11 +0000
tag 535767 pending
thanks

Hello,

Bug #535767 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=devscripts/devscripts.git;a=commitdiff;h=d16f21c

---
commit d16f21c90f5d6c358441be0ac0e11d8202dc94ed
Author: Christoph Berg <myon@debian.org>
Date:   Fri Dec 31 19:39:33 2010 +0100

    Add DEBCHECKOUT_SOURCE config variable

diff --git a/debian/changelog b/debian/changelog
index 44123cc..dccbca4 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,5 +1,6 @@
 devscripts (2.10.70) UNRELEASED; urgency=low
 
+  [ James Vega ]
   * debuild:
     + Properly quote shell variable when parsing options.  (Closes: #556248)
     + Don't treat “-nc” as implying binary only build.  (Closes: #607303)
@@ -11,6 +12,11 @@ devscripts (2.10.70) UNRELEASED; urgency=low
     Thanks to Ben Finney for the patch.  (Closes: #606060)
   * debcheckout: Use the correct prototype for set_destdir.  (Closes: #606053)
 
+  [ Christoph Berg ]
+  * debcheckout: For debian-dir-only repositories, also retrieve the source
+    package, unpack it, and move the missing files over. Add a new option
+    --source (DEBCHECKOUT_SOURCE) to control this behavior. (Closes: #535767)
+
  -- James Vega <jamessan@debian.org>  Thu, 02 Dec 2010 20:27:34 -0500
 
 devscripts (2.10.69) unstable; urgency=low




Message sent on to Joachim Breitner <nomeata@debian.org>:
Bug#535767. (Sat, 01 Jan 2011 19:03:06 GMT) Full text and rfc822 format available.

Message #50 received at 535767-submitter@bugs.debian.org (full text, mbox):

From: James Vega <jamessan@debian.org>
To: 535767-submitter@bugs.debian.org
Subject: Bug#535767 marked as pending
Date: Sat, 01 Jan 2011 19:01:14 +0000
tag 535767 pending
thanks

Hello,

Bug #535767 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=devscripts/devscripts.git;a=commitdiff;h=6768962

---
commit 6768962e969d3dff32ae152daf1fc5e6cd63da26
Merge: 2995d14 52f7db1
Author: James Vega <jamessan@debian.org>
Date:   Sat Jan 1 14:00:05 2011 -0500

    Merge remote branch 'origin/master'

diff --cc debian/changelog
index 8eed35a,f07f924..bab8d4d
--- a/debian/changelog
+++ b/debian/changelog
@@@ -7,13 -8,16 +8,19 @@@ devscripts (2.10.70) UNRELEASED; urgenc
        binary independent packages.
    * pts-subscribe: Handle “--until 0” the same as “--forever”.  (Closes:
      #604740)
 -  * uscan: Update documentation to use “.+” instead of “.*” in groupings.
 -    Thanks to Ben Finney for the patch.  (Closes: #606060)
 +  * uscan:
 +    + Update documentation to use “.+” instead of “.*” in groupings.  Thanks
 +      to Ben Finney for the patch.  (Closes: #606060)
 +    + Add “target” element to --dehs' XML, specifying the name of the
 +      downloaded file.  (Closes: #598514)
    * debcheckout: Use the correct prototype for set_destdir.  (Closes: #606053)
  
+   [ Christoph Berg ]
+   * debcheckout: For debian-dir-only repositories, also retrieve the source
+     package, unpack it, and move the missing files over. Add a new option
+     --source (DEBCHECKOUT_SOURCE) to control this behavior. (Closes: #535767)
+   * Makefiles: Fix parallelization for use with make -j N.
+ 
   -- James Vega <jamessan@debian.org>  Thu, 02 Dec 2010 20:27:34 -0500
  
  devscripts (2.10.69) unstable; urgency=low




Reply sent to James Vega <jamessan@debian.org>:
You have taken responsibility. (Wed, 09 Feb 2011 08:39:12 GMT) Full text and rfc822 format available.

Notification sent to Joachim Breitner <nomeata@debian.org>:
Bug acknowledged by developer. (Wed, 09 Feb 2011 08:39:12 GMT) Full text and rfc822 format available.

Message #55 received at 535767-close@bugs.debian.org (full text, mbox):

From: James Vega <jamessan@debian.org>
To: 535767-close@bugs.debian.org
Subject: Bug#535767: fixed in devscripts 2.10.70
Date: Wed, 09 Feb 2011 08:38:01 +0000
Source: devscripts
Source-Version: 2.10.70

We believe that the bug you reported is fixed in the latest version of
devscripts, which is due to be installed in the Debian FTP archive:

devscripts_2.10.70.dsc
  to main/d/devscripts/devscripts_2.10.70.dsc
devscripts_2.10.70.tar.gz
  to main/d/devscripts/devscripts_2.10.70.tar.gz
devscripts_2.10.70_i386.deb
  to main/d/devscripts/devscripts_2.10.70_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 535767@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
James Vega <jamessan@debian.org> (supplier of updated devscripts package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: RIPEMD160

Format: 1.8
Date: Wed, 09 Feb 2011 02:38:32 -0500
Source: devscripts
Binary: devscripts
Architecture: source i386
Version: 2.10.70
Distribution: unstable
Urgency: low
Maintainer: Devscripts Devel Team <pkg-devscripts@teams.debian.net>
Changed-By: James Vega <jamessan@debian.org>
Description: 
 devscripts - scripts to make the life of a Debian Package maintainer easier
Closes: 513685 535767 556248 589437 595251 598514 600212 604740 606053 606060 607303 610027 610192 610326 612500 612521
Changes: 
 devscripts (2.10.70) unstable; urgency=low
 .
   [ James Vega ]
   * debuild:
     + Properly quote shell variable when parsing options.  (Closes: #556248)
     + Don't treat “-nc” as implying binary only build.  (Closes: #607303)
     + Add recognition of dpkg-buildpackage's “-A” option for building only
       binary independent packages.
   * pts-subscribe: Handle “--until 0” the same as “--forever”.  (Closes:
     #604740)
   * uscan:
     + Update documentation to use “.+” instead of “.*” in groupings.  Thanks
       to Ben Finney for the patch.  (Closes: #606060)
     + Add “target” element to --dehs' XML, specifying the name of the
       downloaded file.  (Closes: #598514)
   * debcheckout: Use the correct prototype for set_destdir.  (Closes: #606053)
   * Use “mktemp --tmpdir” instead of specifying an absolute path under /tmp.
     (Closes: #610027)
   * Fix a typo in debchange(1).  (Closes: #610192)
   * bts: Make the message number optional for the “summary” sub-command.  This
     allows clearing an already set summary.  (Closes: #610326)
   * rmadison: Document udd url shorthand, added in 2.10.62.  (Closes: #589437)
   * Use appropriate typography for literal vs. replacement text in man pages.
     Thanks to David Prévot for the patch and French translation updates.
     (Closes: #600212)
   * dd-list: Ignore extraneous whitespace.  (Closes: #595251)
   * build-rdeps: Remove extraneous EOL whitespace in the output.  (Closes:
     #612500)
   * debian/control: Bump Standards-Version to 3.9.1.0 -- no changes necessary.
 .
   [ Christoph Berg ]
   * debcheckout: For debian-dir-only repositories, also retrieve the source
     package, unpack it, and move the missing files over. Add a new option
     --source (DEBCHECKOUT_SOURCE) to control this behavior. (Closes: #535767)
   * Makefiles: Fix parallelization for use with make -j N.
   * rmadison: New configuration variable: RMADISON_ARCHITECTURE.
     Set the default architecture to use unless overridden by a command line
     option. To see any packages with a set B<RMADISON_ARCHITECTURE>, use
     --architecture='*'. By Uli Martens.
 .
   [ Raphael Geissert ]
   * rmadison: Exit with a non-zero code if curl/wget has a failure.  (Closes:
     #513685)
 .
 devscripts (2.10.69+squeeze1) stable; urgency=low
 .
   * bts: Accept the "wheezy" and "wheezy-ignore" tags.  (Closes: #612521)
   * debchange:
     + Set Squeeze as the default backports target.
     + Recognize "lenny-backports-sloppy" and "squeeze-backports"
       distributions.
     + Remove "etch-backports" and "etch-volatile" distributions.
Checksums-Sha1: 
 52431b6cb159f3b695f9dc15317fff26b03c5fec 1445 devscripts_2.10.70.dsc
 b58c17ec5b030ed2db7e453a91960506bc48b123 728675 devscripts_2.10.70.tar.gz
 ea9affab9066e6e9990ec0c4fed00e87bd8245e1 655352 devscripts_2.10.70_i386.deb
Checksums-Sha256: 
 9ebd8530d928adb5d1094c59e2dbe927263aeb833e1f9b0f3fe2e838b3c2fbcb 1445 devscripts_2.10.70.dsc
 c95e24dc18b8b3e530d18f82a576ef87895df8777e468b33e704320ea3883ab8 728675 devscripts_2.10.70.tar.gz
 daa11c0132409ad861d58611cd9bea71ea78d757117ac9bbc1b3ba6b3b1ce6b6 655352 devscripts_2.10.70_i386.deb
Files: 
 cf0311b295fe8ccd8c66412bc240425c 1445 devel optional devscripts_2.10.70.dsc
 a539744649f8eee48b7be83835dd01b8 728675 devel optional devscripts_2.10.70.tar.gz
 c7479e4a31a4720f3d0b38dfa15a9a99 655352 devel optional devscripts_2.10.70_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEAREDAAYFAk1SRkUACgkQDb3UpmEybUDOLACgmeQvh0NG1s0FfGF0PqVSfzNJ
YQkAoIpQxup5XIa0DTsQ4ComSR462c3B
=KEeh
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 16 Mar 2011 07:48:38 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:29:53 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.